/*
 *  Copyright (C) 2009  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */


#include <linux/init.h>
#include <linux/module.h>
#include <linux/workqueue.h>

MODULE_LICENSE("GPL");

static struct workqueue_struct *mywq;

static void do_mywork(struct work_struct *data)
{
	printk(KERN_INFO "I've been scheduled.\n");
	queue_delayed_work(mywq, to_delayed_work(data), 8 * HZ);
}

DECLARE_DELAYED_WORK(mywork, do_mywork);

static int mywq_init(void)
{
	mywq = create_workqueue("mywq");
	printk(KERN_INFO "Here I am, this is me.\n");
	queue_delayed_work(mywq, &mywork, 8 * HZ);
	return 0;
}

static void mywq_exit(void)
{
	flush_workqueue(mywq);
	destroy_workqueue(mywq);
}

module_init(mywq_init);
module_exit(mywq_exit);
